Index: trunk/VUT/GtpVisibility/include/QueryManager.h
===================================================================
--- trunk/VUT/GtpVisibility/include/QueryManager.h	(revision 65)
+++ trunk/VUT/GtpVisibility/include/QueryManager.h	(revision 71)
@@ -19,7 +19,7 @@
     output of the visibility preprocessor.
 */
-  class QueryManager
-  {
-  public:
+class QueryManager
+{
+public:
     /** Constructor taking a hierarchy interface as an argument. This allows to operate
 	onm different hierarchy types, while reusing the implementation of the query methods.
@@ -74,5 +74,5 @@
 
       @return true if there is any intersection. 
-  */
+	*/
     virtual bool
     ShootRay(const Ray &ray,
@@ -81,8 +81,8 @@
 	     );
   
-  /** Sets the scene traverser.
+	/** Sets the scene traverser.
       @remark the scene traverser depends on the type of hierarchyInterface the scene consists of.
-  */
-  void SetSceneTraverser(HierarchyInterface *hierarchyInterface );
+	*/
+	void SetSceneTraverser(HierarchyInterface *hierarchyInterface );
 
 protected:
Index: trunk/VUT/GtpVisibility/include/VisibilityInfo.h
===================================================================
--- trunk/VUT/GtpVisibility/include/VisibilityInfo.h	(revision 65)
+++ trunk/VUT/GtpVisibility/include/VisibilityInfo.h	(revision 71)
@@ -9,13 +9,12 @@
 namespace GtpVisibility {
   
-  /** Class storing the visibility information of a scene node. 
-   */
-  class NodeInfo {
-  public:
-    NodeInfo(HierarchyNode *node,
-	     const float v):
-      mNode(node), mVisibility(v) {}
+/** Class storing the visibility information of a scene node. 
+*/
+class NodeInfo 
+{
+public:
+    NodeInfo(HierarchyNode *node,const float v): mNode(node), mVisibility(v) {}
 
-  protected:
+protected:
     /** pointer to the scene node */
     HierarchyNode *mNode;
@@ -24,25 +23,25 @@
 	total number of ratsterized pixels */
     float mVisibility;
-  };
+};
   
+/** Class storing the visibility information of a mesh.
+*/
+class MeshInfo 
+{
+public:
+	MeshInfo(Mesh *mesh, const float v): mMesh(mesh), mVisibility(v) {}
+
+protected:
+    /** Pointer to the mesh.
+	*/
+    Mesh *mMesh;
+    /** Node visibility can either be a number of visible pixels or relative
+	number of visible pixels (if the hardware queries will provide the
+	total number of ratsterized pixels.
+	*/
+    float mVisibility;
+};
   
-  /** Class storing the visibility information of a mesh. 
-   */
-  class MeshInfo {
-  public:
-    MeshInfo(Mesh *mesh,
-	     const float v):
-      mMesh(mesh), mVisibility(v) {}
-
-  protected:
-    /** pointer to the scene node */
-    Mesh *mMesh;
-    /** node visibility can either be a number of visible pixels or relative
-	number of visible pixels (if the hardware queries will provide the
-	total number of ratsterized pixels */
-    float mVisibility;
-  };
-  
-  // this define shall be replaced by template typedef
+//TODO: this define shall be replaced by template typedef
 #define InfoContainer std::vector
 };
Index: trunk/VUT/GtpVisibility/include/VisibilityMesh.h
===================================================================
--- trunk/VUT/GtpVisibility/include/VisibilityMesh.h	(revision 65)
+++ trunk/VUT/GtpVisibility/include/VisibilityMesh.h	(revision 71)
@@ -9,4 +9,3 @@
 
 
-
-#endif
+#endif // VisibilityMesh.h
Index: trunk/VUT/GtpVisibility/include/VisibilityEnvironment.h
===================================================================
--- trunk/VUT/GtpVisibility/include/VisibilityEnvironment.h	(revision 59)
+++ trunk/VUT/GtpVisibility/include/VisibilityEnvironment.h	(revision 71)
@@ -20,3 +20,6 @@
 };
 } // namespace GtpVisibility
+
+/** @}*/ // end of group Visibility
+
 #endif // VisibilityEnvironment_H
Index: trunk/VUT/GtpVisibility/include/PreprocessingManager.h
===================================================================
--- trunk/VUT/GtpVisibility/include/PreprocessingManager.h	(revision 67)
+++ trunk/VUT/GtpVisibility/include/PreprocessingManager.h	(revision 71)
@@ -11,59 +11,54 @@
 namespace GtpVisibility {
   
-  /**
-     This class defines an interface to the external visibility preprocessor.
-     It allows to export the static part of the scene to a file in the XML format
-     understood by the preprocessor. By default all the exported meshes are considered
-     as scene occluders, whereas occludees are formed by their bounding boxes,
-     and bounding boxes of the scene hierarchy.
+/**
+	This class defines an interface to the external visibility preprocessor.
+    It allows to export the static part of the scene to a file in the XML format
+    understood by the preprocessor. By default all the exported meshes are considered
+    as scene occluders, whereas occludees are formed by their bounding boxes,
+    and bounding boxes of the scene hierarchy.
 
-     This class also allows to import the preprocessed data with PVS
-     information for the viewcells (note that the viewcells are either generated
-     automatically by the preprocessor or loaded from a polyhedral definition stored
-     in a file (see documentation for the Preprocessor class).
-  */
+    This class also allows to import the preprocessed data with PVS
+    information for the viewcells (note that the viewcells are either generated
+    automatically by the preprocessor or loaded from a polyhedral definition stored
+    in a file (see documentation for the Preprocessor class).
+*/
   
-  class PreprocessingManager
-  {
-  public:
+class PreprocessingManager
+{
+public:
     
-    /**
-       Constructor taking a HierarchyInterface as argument.
-       The HierarchyInterface makes the PreprocessingManager independent from the actual
-       scene representation as long as it supports a required set of methods.
-     */
-    PreprocessingManager( HierarchyInterface *hierarchyInterface );
+	/** Constructor taking a HierarchyInterface as argument.
+        The HierarchyInterface makes the PreprocessingManager independent from the actual
+        scene representation as long as it supports a required set of methods.
+    */
+    PreprocessingManager(HierarchyInterface *hierarchyInterface);
     
 
     /**
-       Destructor which deletes all data describing static scene visibility.
+        Destructor which deletes all data describing static scene visibility.
     */
     virtual ~PreprocessingManager();
 
-    /**
-       Export the scene for visibility preprocessing. Exports the hierarchyInterface including
-       its bounding boxes + mesh data. Note that the bounding boxes can be used as occludees
-       by the extrenal preprocessor. The viewcell data will either be supplied directly to the
-       visibility preprocessing standalone module.
+    /** Export the scene for visibility preprocessing. Exports the hierarchyInterface including
+        its bounding boxes + mesh data. Note that the bounding boxes can be used as occludees
+        by the extrenal preprocessor. The viewcell data will either be supplied directly to the
+        visibility preprocessing standalone module.
 
-       @param filename name of the file to export.
-       @return true if the export was succesful.
+        @param filename name of the file to export.
+        @return true if the export was succesful.
     */
-    virtual bool ExportScene(const string filename
-			     ) = 0;
+    virtual bool ExportScene(const string filename) = 0;
     
-    /**
-       Load preprocessed visibility information. The loaded data is matched with the current
-       scene graph. The topology of the current scene graph has to match with the loaded data.
-       There is also geometrical check of the bounding boxes. Once loading is succesful the
-       PreprocessingManager establishes links from its internal visibility representation
-       to the scene graph: no change of this part of the scene graph is allowed; this would
-       violate the static scene assumption!
+	/** Load preprocessed visibility information. The loaded data is matched with the current
+        scene graph. The topology of the current scene graph has to match with the loaded data.
+        There is also geometrical check of the bounding boxes. Once loading is succesful the
+        PreprocessingManager establishes links from its internal visibility representation
+        to the scene graph: no change of this part of the scene graph is allowed; this would
+        violate the static scene assumption!
 
-       @param filename name of the file to load.
-       @return true if the loading was succesful.
+        @param filename name of the file to load.
+        @return true if the loading was succesful.
     */
-    virtual bool LoadPreprocessedData(const string filename
-				      ) = 0;
+    virtual bool LoadPreprocessedData(const string filename) = 0;
     
     /** 
Index: trunk/VUT/GtpVisibility/include/VisibilityManager.h
===================================================================
--- trunk/VUT/GtpVisibility/include/VisibilityManager.h	(revision 65)
+++ trunk/VUT/GtpVisibility/include/VisibilityManager.h	(revision 71)
@@ -1,8 +1,7 @@
-#ifndef _Manager_H__
-#define _Manager_H__
+#ifndef _VisibilityManager_H__
+#define _VisibilityManager_H__
 
 #include "CullingManager.h"
 #include "VisibilityEnvironment.h"
-
 
 /** This namespace includes all classes which are created by the VUT (Vienna University
@@ -10,5 +9,4 @@
 	and are not directly derived from an Ogre class.
 */
-
 namespace GtpVisibility {
 
@@ -52,3 +50,4 @@
 };
 } // namespace GtpVisibility
+
 #endif // VisibilityManager
Index: trunk/VUT/GtpVisibility/scripts/GtpVisibility.vcproj
===================================================================
--- trunk/VUT/GtpVisibility/scripts/GtpVisibility.vcproj	(revision 64)
+++ trunk/VUT/GtpVisibility/scripts/GtpVisibility.vcproj	(revision 71)
@@ -20,5 +20,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;..\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_LIB"
 				MinimalRebuild="TRUE"
@@ -106,8 +106,20 @@
 			</File>
 			<File
+				RelativePath="..\src\DummyPreprocessingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\DummyQueryManager.cpp">
+			</File>
+			<File
 				RelativePath="..\src\FrustumCullingManager.cpp">
 			</File>
 			<File
 				RelativePath="..\src\HierarchyInterface.cpp">
+			</File>
+			<File
+				RelativePath="..\src\PreprocessingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\QueryManager.cpp">
 			</File>
 			<File
@@ -161,4 +173,7 @@
 				RelativePath="..\include\VisibilityManager.h">
 			</File>
+			<File
+				RelativePath="..\include\VisibilityMesh.h">
+			</File>
 		</Filter>
 	</Files>
Index: trunk/VUT/GtpVisibility/src/PreprocessingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/PreprocessingManager.cpp	(revision 65)
+++ trunk/VUT/GtpVisibility/src/PreprocessingManager.cpp	(revision 71)
@@ -3,23 +3,26 @@
 namespace GtpVisibility {
   
-  
-  bool
-  PreprocessingManager::GetPVS(
-			       const Vector3 &center,
-			       const float radius,
-			       InfoContainer<NodeInfo> *visibleNodes,
-			       InfoContainer<MeshInfo> *visibleMeshes )
-  {
+PreprocessingManager::PreprocessingManager(HierarchyInterface *hierarchyInterface)
+{
+}
+
+PreprocessingManager::~PreprocessingManager()
+{
+}
+
+bool PreprocessingManager::GetPVS(const Vector3 &center,
+								  const float radius,
+								  InfoContainer<NodeInfo> *visibleNodes,
+								  InfoContainer<MeshInfo> *visibleMeshes)
+{
     vector<int> viewCellIds;
-    if (LocateViewCellIds(center, radius, &viewCellIds)) {
-      for (vector<int>::iterator ci = viewCellIds.begin();
-	   ci != viewCellIds.end();
-	   ci++) {
-	AddViewCellPVS(*ci,
-		       visibleNodes,
-		       visibleMeshes );
-	// remove duplicates of the PVS entries if any?
-      }
-      return true;
+    if (LocateViewCellIds(center, radius, &viewCellIds)) 
+	{
+		for (vector<int>::iterator ci = viewCellIds.begin(); ci != viewCellIds.end(); ci++) 
+		{
+			AddViewCellPVS(*ci, visibleNodes, visibleMeshes );
+			// remove duplicates of the PVS entries if any?
+		}
+		return true;
     }
     return false;
Index: trunk/VUT/GtpVisibility/src/QueryManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/QueryManager.cpp	(revision 65)
+++ trunk/VUT/GtpVisibility/src/QueryManager.cpp	(revision 71)
@@ -3,17 +3,14 @@
 
 namespace GtpVisibility {
+ 
+QueryManager::QueryManager(HierarchyInterface *hierarchyInterface)
+{
+}
+ 
+bool QueryManager::ShootRay(const Ray &ray, std::vector<Mesh *> *visibleMeshes, bool isGlobalLine)
+{
+    // run OGRE ray shooting query
+    return false;
+}
   
-  bool
-  QueryManager::ShootRay(const Ray &ray,
-			 std::vector<Mesh *> *visibleMeshes,
-			 bool isGlobalLine
-			 )
-  {
-    // run OGRE ray shooting query
-    
-
-    return false;
-  }
-  
-  
-};
+} // namespace GtpVisibility