Index: /trunk/VUT/doc/DummyModules/refman_edited.tex
===================================================================
--- /trunk/VUT/doc/DummyModules/refman_edited.tex	(revision 73)
+++ /trunk/VUT/doc/DummyModules/refman_edited.tex	(revision 73)
@@ -0,0 +1,177 @@
+\documentclass[a4paper]{book}
+\usepackage{a4wide}
+\usepackage{makeidx}
+\usepackage{fancyhdr}
+\usepackage{graphicx}
+\usepackage{multicol}
+\usepackage{float}
+\usepackage{textcomp}
+\usepackage{alltt}
+\usepackage{times}
+\usepackage{pdfpages}
+\ifx\pdfoutput\undefined
+\usepackage[ps2pdf,
+            pagebackref=true,
+            colorlinks=true,
+            linkcolor=blue
+           ]{hyperref}
+\usepackage{pspicture}
+\else
+\usepackage[pdftex,
+            pagebackref=true,
+            colorlinks=true,
+            linkcolor=blue
+           ]{hyperref}
+\fi
+\usepackage{doxygen}
+\makeindex
+\setcounter{tocdepth}{1}
+\renewcommand{\footrulewidth}{0.4pt}
+\begin{document}
+%\begin{titlepage}
+%\vspace*{7cm}
+%\begin{center}
+%{\Large Game\-Tools Geometry Modules Reference Manual\\[1ex]\large 0.1 }\\
+%\vspace*{1cm}
+%{\large Generated by Doxygen 1.4.0}\\
+%\vspace*{0.5cm}
+%{\small Tue Apr 19 12:57:03 2005}\\
+%\end{center}
+%\end{titlepage}
+\includepdf[pages=1-2]{../cover.pdf}
+\clearemptydoublepage
+\pagenumbering{roman}
+\tableofcontents
+\clearemptydoublepage
+\pagenumbering{arabic}
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\input{../overview}
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\chapter{Game\-Tools Visibility Modules Hierarchical Index}
+\input{hierarchy}
+\chapter{Game\-Tools Visibility Modules Class Documentation}
+\input{class_ogre_1_1_bsp_hierarchy_interface}
+\include{class_ogre_1_1_octree_hierarchy_interface}
+\include{class_ogre_1_1_platform_hierarchy_interface}
+\include{class_ogre_1_1_platform_occlusion_query}
+\include{class_ogre_1_1_scene_node_hierarchy_interface}
+\include{class_ogre_1_1_solid_half_bounding_box}
+\include{class_ogre_1_1_visibility_bsp_scene_manager}
+\include{class_ogre_1_1_visibility_dot_scene_manager}
+\include{class_ogre_1_1_visibility_octree_scene_manager}
+\include{class_ogre_1_1_visibility_scene_manager}
+\include{class_ogre_1_1_visibility_terrain_scene_manager}
+\include{class_gtp_visibility_1_1_coherent_hierarchical_culling_manager}
+\include{class_gtp_visibility_1_1_culling_manager}
+\include{class_gtp_visibility_1_1_dummy_preprocessing_manager}
+\include{class_gtp_visibility_1_1_dummy_query_manager}
+\include{class_gtp_visibility_1_1_frustum_culling_manager}
+\include{class_gtp_visibility_1_1_greater_distance}
+\include{class_gtp_visibility_1_1_hierarchy_interface}
+\include{class_gtp_visibility_1_1_mesh_info}
+\include{class_gtp_visibility_1_1_node_info}
+\include{class_gtp_visibility_1_1_occlusion_query}
+\include{class_gtp_visibility_1_1_preprocessing_manager}
+\include{class_gtp_visibility_1_1_query_manager}
+\include{class_gtp_visibility_1_1_stop_and_wait_culling_manager}
+\include{class_gtp_visibility_1_1_visibility_environment}
+\include{class_gtp_visibility_1_1_visibility_manager}
+\include{class_gtp_visibility_preprocessor_1_1_axis_aligned_box3}
+\include{class_gtp_visibility_preprocessor_1_1_b_s_p_interior}
+\include{class_gtp_visibility_preprocessor_1_1_b_s_p_leaf}
+\include{class_gtp_visibility_preprocessor_1_1_b_s_p_node}
+\include{class_gtp_visibility_preprocessor_1_1_b_s_p_tree}
+\include{class_gtp_visibility_preprocessor_1_1_exact_preprocessor}
+\include{class_gtp_visibility_preprocessor_1_1_kd_interior}
+\include{class_gtp_visibility_preprocessor_1_1_kd_leaf}
+\include{class_gtp_visibility_preprocessor_1_1_kd_node}
+\include{class_gtp_visibility_preprocessor_1_1_kd_tree}
+\include{class_gtp_visibility_preprocessor_1_1_mesh}
+\include{class_gtp_visibility_preprocessor_1_1_patch}
+\include{class_gtp_visibility_preprocessor_1_1_plane3}
+\include{class_gtp_visibility_preprocessor_1_1_preprocessor}
+\include{class_gtp_visibility_preprocessor_1_1_sampling_preprocessor}
+\include{class_gtp_visibility_preprocessor_1_1_scene_graph}
+\include{class_gtp_visibility_preprocessor_1_1_scene_graph_node}
+\include{class_gtp_visibility_preprocessor_1_1_vector3}
+\chapter{Game\-Tools Visibility Modules Namespace Documentation}
+\input{namespace_gtp_visibility}
+\include{namespace_gtp_visibility_preprocessor}
+\include{namespace_ogre}
+\chapter{Game\-Tools Visibility Modules File Documentation}
+\input{_axis_aligned_box3_8h}
+\include{_coherent_hierarchical_culling_manager_8cpp}
+\include{_coherent_hierarchical_culling_manager_8h}
+\include{_containers_8h}
+\include{_culling_manager_8cpp}
+\include{_culling_manager_8h}
+\include{_distance_queue_8h}
+\include{_dummy_preprocessing_manager_8cpp}
+\include{_dummy_preprocessing_manager_8h}
+\include{_dummy_query_manager_8cpp}
+\include{_dummy_query_manager_8h}
+\include{_exact_preprocessor_8cpp}
+\include{_exact_preprocessor_8h}
+\include{_frustum_culling_manager_8cpp}
+\include{_frustum_culling_manager_8h}
+\include{_hierarchy_interface_8cpp}
+\include{_hierarchy_interface_8h}
+\include{_kd_tree_8cpp}
+\include{_kd_tree_8h}
+\include{_mesh_8h}
+\include{_occlusion_query_8h}
+\include{_ogre_bsp_hierarchy_interface_8cpp}
+\include{_ogre_bsp_hierarchy_interface_8h}
+\include{_ogre_octree_hierarchy_interface_8cpp}
+\include{_ogre_octree_hierarchy_interface_8h}
+\include{_ogre_platform_hierarchy_interface_8cpp}
+\include{_ogre_platform_hierarchy_interface_8h}
+\include{_ogre_platform_occlusion_query_8cpp}
+\include{_ogre_platform_occlusion_query_8h}
+\include{_ogre_scene_node_hierarchy_interface_8cpp}
+\include{_ogre_scene_node_hierarchy_interface_8h}
+\include{_ogre_solid_half_bounding_box_8cpp}
+\include{_ogre_solid_half_bounding_box_8h}
+\include{_ogre_visibility_bsp_scene_manager_8cpp}
+\include{_ogre_visibility_bsp_scene_manager_8h}
+\include{_ogre_visibility_dot_scene_manager_8cpp}
+\include{_ogre_visibility_dot_scene_manager_8h}
+\include{_ogre_visibility_octree_scene_manager_8cpp}
+\include{_ogre_visibility_octree_scene_manager_8h}
+\include{_ogre_visibility_scene_manager_8cpp}
+\include{_ogre_visibility_scene_manager_8h}
+\include{_ogre_visibility_scene_manager_dll_8cpp}
+\include{_ogre_visibility_terrain_scene_manager_8cpp}
+\include{_ogre_visibility_terrain_scene_manager_8h}
+\include{_plane3_8h}
+\include{_preprocessing_manager_8cpp}
+\include{_preprocessing_manager_8h}
+\include{_preprocessor_8cpp}
+\include{_preprocessor_8h}
+\include{_query_manager_8cpp}
+\include{_query_manager_8h}
+\include{_sampling_preprocessor_8cpp}
+\include{_sampling_preprocessor_8h}
+\include{_scene_graph_8h}
+\include{_stop_and_wait_culling_manager_8cpp}
+\include{_stop_and_wait_culling_manager_8h}
+\include{_vector3_8h}
+\include{_view_cell_b_s_p_8h}
+\include{_visibility_axis_aligned_box_8h}
+\include{_visibility_camera_8h}
+\include{_visibility_environment_8cpp}
+\include{_visibility_environment_8h}
+\include{_visibility_info_8h}
+\include{_visibility_manager_8cpp}
+\include{_visibility_manager_8h}
+\include{_visibility_mesh_8h}
+\include{_visibility_ray_8h}
+\include{_visibility_vector3_8h}
+\chapter{Game\-Tools Visibility Modules Class Index}
+\input{annotated}
+\chapter{Game\-Tools Visibility Modules Namespace Index}
+\input{namespaces}
+\chapter{Game\-Tools Visibility Modules File Index}
+\input{files}
+\printindex
+\end{document}
Index: /trunk/VUT/doc/DummyModules/doxyfile_gtp_dummy
===================================================================
--- /trunk/VUT/doc/DummyModules/doxyfile_gtp_dummy	(revision 71)
+++ /trunk/VUT/doc/DummyModules/doxyfile_gtp_dummy	(revision 73)
@@ -1,3 +1,3 @@
- Doxyfile 1.4.2
+#Doxyfile 1.4.2
 
 #---------------------------------------------------------------------------
@@ -25,7 +25,7 @@
 ALWAYS_DETAILED_SEC    = NO
 INLINE_INHERITED_MEMB  = NO
-FULL_PATH_NAMES        = YES
-STRIP_FROM_PATH        = "d:/gametools/trunk/VUT/"
-STRIP_FROM_INC_PATH    = 
+FULL_PATH_NAMES        = NO
+#STRIP_FROM_PATH        = "d:/gametools/trunk/VUT/"
+STRIP_FROM_INC_PATH    = "d:\gametools\svn\trunk\VUT"
 SHORT_NAMES            = NO
 JAVADOC_AUTOBRIEF      = NO
@@ -58,6 +58,6 @@
 INLINE_INFO            = YES
 SORT_MEMBER_DOCS       = NO
-SORT_BRIEF_DOCS        = YES
-SORT_BY_SCOPE_NAME     = YES
+SORT_BRIEF_DOCS        = NO
+#SORT_BY_SCOPE_NAME     = YES
 GENERATE_TODOLIST      = YES
 GENERATE_TESTLIST      = YES
@@ -67,5 +67,5 @@
 MAX_INITIALIZER_LINES  = 30
 SHOW_USED_FILES        = YES
-SHOW_DIRECTORIES       = YES
+SHOW_DIRECTORIES       = NO
 FILE_VERSION_FILTER    = 
 #---------------------------------------------------------------------------
@@ -246,5 +246,5 @@
 CALL_GRAPH             = YES
 GRAPHICAL_HIERARCHY    = YES
-DIRECTORY_GRAPH        = YES
+DIRECTORY_GRAPH        = NO
 DOT_IMAGE_FORMAT       = png
 DOT_PATH               = 