Index: trunk/VUT/Ogre/resources/VisibilityDemo.overlay
===================================================================
--- trunk/VUT/Ogre/resources/VisibilityDemo.overlay	(revision 74)
+++ trunk/VUT/Ogre/resources/VisibilityDemo.overlay	(revision 74)
@@ -0,0 +1,235 @@
+Example/VisibilityDemoOverlay
+{
+	zorder 500
+	// Stats block
+	container BorderPanel(Example/Visibility/VisibilityPanel)
+	{
+		metrics_mode pixels
+		vert_align top
+		left 5 
+		top 5
+		width 450
+		height 55
+		material Core/StatsBlockCenter
+        	border_size 1 1 1 1
+        	border_material Core/StatsBlockBorder
+        	border_topleft_uv     0.0000 1.0000 0.0039 0.9961
+	    	border_top_uv         0.0039 1.0000 0.9961 0.9961
+	    	border_topright_uv    0.9961 1.0000 1.0000 0.9961
+	    	border_left_uv        0.0000 0.9961 0.0039 0.0039
+	    	border_right_uv       0.9961 0.9961 1.0000 0.0039
+	    	border_bottomleft_uv  0.0000 0.0039 0.0039 0.0000
+        	border_bottom_uv      0.0039 0.0039 0.9961 0.0000
+	    	border_bottomright_uv 0.9961 0.0039 1.0000 0.0000
+
+
+		element TextArea(Example/Visibility/Algorithm)
+		{
+			metrics_mode pixels
+			left 5
+			top 5
+			width 180
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption [A] Algorithm
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/AlgorithmInfo)
+		{
+			metrics_mode pixels
+			left 155
+			top 5
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+
+		element TextArea(Example/Visibility/Threshold)
+		{
+			metrics_mode pixels
+			left 5
+			top 20
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption [-][+] Threshold
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/ThresholdInfo)
+		{
+			metrics_mode pixels
+			left 155
+			top 20
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+	}
+
+	container BorderPanel(Example/Visibility/VisibilityStatsPanel)
+	{
+		metrics_mode pixels
+		vert_align top
+		horz_align right
+		left -355 
+		top 5
+		width 450
+		height 90
+		material Core/StatsBlockCenter
+        	border_size 1 1 1 1
+        	border_material Core/StatsBlockBorder
+        	border_topleft_uv     0.0000 1.0000 0.0039 0.9961
+	    	border_top_uv         0.0039 1.0000 0.9961 0.9961
+	    	border_topright_uv    0.9961 1.0000 1.0000 0.9961
+	    	border_left_uv        0.0000 0.9961 0.0039 0.0039
+	    	border_right_uv       0.9961 0.9961 1.0000 0.0039
+	    	border_bottomleft_uv  0.0000 0.0039 0.0039 0.0000
+        	border_bottom_uv      0.0039 0.0039 0.9961 0.0000
+	    	border_bottomright_uv 0.9961 0.0039 1.0000 0.0000
+
+		element TextArea(Example/Visibility/FrustumCulledNodes)
+		{
+			metrics_mode pixels
+			left 5
+			top 5
+			width 180
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption Frustum Culled Nodes
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/FrustumCulledNodesInfo)
+		{
+			metrics_mode pixels
+			left 180
+			top 5
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/QueryCulledNodes)
+		{
+			metrics_mode pixels
+			left 5
+			top 20
+			width 180
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption Query Culled Nodes
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}	
+		element TextArea(Example/Visibility/QueryCulledNodesInfo)
+		{
+			metrics_mode pixels
+			left 180
+			top 20
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/TraversedNodes)
+		{
+			metrics_mode pixels
+			left 5
+			top 35
+			width 180
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption Traversed Nodes
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}	
+		element TextArea(Example/Visibility/TraversedNodesInfo)
+		{
+			metrics_mode pixels
+			left 180
+			top 35
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/HierarchyNodes)
+		{
+			metrics_mode pixels
+			left 5
+			top 50
+			width 180
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption Hierarchy Nodes
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}	
+		element TextArea(Example/Visibility/HierarchyNodesInfo)
+		{
+			metrics_mode pixels
+			left 180
+			top 50
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+		element TextArea(Example/Visibility/RenderedNodes)
+		{
+			metrics_mode pixels
+			left 5
+			top 65
+			width 180
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption Rendered Nodes
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}	
+		element TextArea(Example/Visibility/RenderedNodesInfo)
+		{
+			metrics_mode pixels
+			left 180
+			top 65
+			width 90
+			height 30
+			font_name TrebuchetMSBold
+			char_height 16
+			caption :
+			colour_top 0.5 0.7 0.5
+			colour_bottom 0.3 0.5 0.3
+		}
+
+
+	}
+}
Index: trunk/VUT/Ogre/resources/OcclusionCullingDemo.overlay
===================================================================
--- trunk/VUT/Ogre/resources/OcclusionCullingDemo.overlay	(revision 59)
+++ 	(revision )
@@ -1,261 +1,0 @@
-Example/OcclusionCullingDemoOverlay
-{
-	zorder 500
-	// Stats block
-	container BorderPanel(Example/Occlusion/OcclusionPanel)
-	{
-		metrics_mode pixels
-		vert_align top
-		left 5 
-		top 5
-		width 450
-		height 55
-		material Core/StatsBlockCenter
-        	border_size 1 1 1 1
-        	border_material Core/StatsBlockBorder
-        	border_topleft_uv     0.0000 1.0000 0.0039 0.9961
-	    	border_top_uv         0.0039 1.0000 0.9961 0.9961
-	    	border_topright_uv    0.9961 1.0000 1.0000 0.9961
-	    	border_left_uv        0.0000 0.9961 0.0039 0.0039
-	    	border_right_uv       0.9961 0.9961 1.0000 0.0039
-	    	border_bottomleft_uv  0.0000 0.0039 0.0039 0.0000
-        	border_bottom_uv      0.0039 0.0039 0.9961 0.0000
-	    	border_bottomright_uv 0.9961 0.0039 1.0000 0.0000
-
-
-		element TextArea(Example/Occlusion/Algorithm)
-		{
-			metrics_mode pixels
-			left 5
-			top 5
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption [A] Algorithm
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/AlgorithmInfo)
-		{
-			metrics_mode pixels
-			left 155
-			top 5
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-
-		element TextArea(Example/Occlusion/Threshold)
-		{
-			metrics_mode pixels
-			left 5
-			top 20
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption [-][+] Threshold
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/ThresholdInfo)
-		{
-			metrics_mode pixels
-			left 155
-			top 20
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-	}
-
-	container BorderPanel(Example/Occlusion/OcclusionStatsPanel)
-	{
-		metrics_mode pixels
-		vert_align top
-		horz_align right
-		left -355 
-		top 5
-		width 450
-		height 105
-		material Core/StatsBlockCenter
-        	border_size 1 1 1 1
-        	border_material Core/StatsBlockBorder
-        	border_topleft_uv     0.0000 1.0000 0.0039 0.9961
-	    	border_top_uv         0.0039 1.0000 0.9961 0.9961
-	    	border_topright_uv    0.9961 1.0000 1.0000 0.9961
-	    	border_left_uv        0.0000 0.9961 0.0039 0.0039
-	    	border_right_uv       0.9961 0.9961 1.0000 0.0039
-	    	border_bottomleft_uv  0.0000 0.0039 0.0039 0.0000
-        	border_bottom_uv      0.0039 0.0039 0.9961 0.0000
-	    	border_bottomright_uv 0.9961 0.0039 1.0000 0.0000
-
-		element TextArea(Example/Occlusion/FrustumCulledNodes)
-		{
-			metrics_mode pixels
-			left 5
-			top 5
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption Frustum Culled Nodes
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/FrustumCulledNodesInfo)
-		{
-			metrics_mode pixels
-			left 180
-			top 5
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/QueryCulledNodes)
-		{
-			metrics_mode pixels
-			left 5
-			top 20
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption Query Culled Nodes
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}	
-		element TextArea(Example/Occlusion/QueryCulledNodesInfo)
-		{
-			metrics_mode pixels
-			left 180
-			top 20
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/TraversedNodes)
-		{
-			metrics_mode pixels
-			left 5
-			top 35
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption Traversed Nodes
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}	
-		element TextArea(Example/Occlusion/TraversedNodesInfo)
-		{
-			metrics_mode pixels
-			left 180
-			top 35
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/SceneNodes)
-		{
-			metrics_mode pixels
-			left 5
-			top 50
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption Scene Nodes
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}	
-		element TextArea(Example/Occlusion/SceneNodesInfo)
-		{
-			metrics_mode pixels
-			left 180
-			top 50
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/HierarchyNodes)
-		{
-			metrics_mode pixels
-			left 5
-			top 65
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption Hierarchy Nodes
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}	
-		element TextArea(Example/Occlusion/HierarchyNodesInfo)
-		{
-			metrics_mode pixels
-			left 180
-			top 65
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-		element TextArea(Example/Occlusion/RenderedNodes)
-		{
-			metrics_mode pixels
-			left 5
-			top 80
-			width 180
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption Rendered Nodes
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}	
-		element TextArea(Example/Occlusion/RenderedNodesInfo)
-		{
-			metrics_mode pixels
-			left 180
-			top 80
-			width 90
-			height 30
-			font_name TrebuchetMSBold
-			char_height 16
-			caption :
-			colour_top 0.5 0.7 0.5
-			colour_bottom 0.3 0.5 0.3
-		}
-
-
-	}
-}