Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 80)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 82)
@@ -21,5 +21,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;../../GtpVisibility/include;../include"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\GtpVisibility\include;..\include;..\TestCulling"
 				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_DEBUG;WIN32;_STLP_DEBUG;PLUGIN_TERRAIN_IMPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
 				MinimalRebuild="TRUE"
@@ -122,5 +122,5 @@
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
 			<File
-				RelativePath=".\SceneContentGenerator.cpp">
+				RelativePath="..\TestCulling\SceneContentGenerator.cpp">
 			</File>
 			<File
@@ -136,5 +136,5 @@
 			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
 			<File
-				RelativePath=".\SceneContentGenerator.h">
+				RelativePath="..\TestCulling\SceneContentGenerator.h">
 			</File>
 			<File
Index: trunk/VUT/work/TestCullingTerrain/TerrainContentGenerator.cpp
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TerrainContentGenerator.cpp	(revision 81)
+++ trunk/VUT/work/TestCullingTerrain/TerrainContentGenerator.cpp	(revision 82)
@@ -19,5 +19,6 @@
 }
 //-----------------------------------------------------------------------
-bool RayQueryExecutor::executeRayQuery(Vector3 *result, const Vector3 &pos, const Vector3 &dir)
+bool RayQueryExecutor::executeRayQuery(Vector3 *result, const Vector3 &pos, 
+									   const Vector3 &dir)
 {
 	return executeRayQuery(result, Ray(pos, dir));
@@ -52,5 +53,5 @@
 {
 	mMinPos = Vector3(0.0f, 5000.0f, 0.0f);
-	mMaxPos =Vector3(1000.0f, 5000.0f, 1000.0f);
+	mMaxPos = Vector3(1000.0f, 5000.0f, 1000.0f);
 
 	mMinAngle = Vector3(0.0f, 0.0f, 0.0f);
@@ -72,5 +73,5 @@
 	if (mRayQueryExecutor->executeRayQuery(&queryResult, position, Vector3::NEGATIVE_UNIT_Y))
 	{
-		// reject if height too big
+		// reject if height is too high
 		if(queryResult.y < mMaxHeight)
 		{
Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.cpp
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.cpp	(revision 80)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.cpp	(revision 82)
@@ -25,5 +25,5 @@
 TestCullingTerrainApplication::~TestCullingTerrainApplication()
 {
-	delete mSceneContentGenerator;
+	delete mTerrainContentGenerator;
 }
 //-----------------------------------------------------------------------
@@ -95,8 +95,8 @@
 	mSceneMgr->_renderScene(mCamera, mWindow->getViewport(0), true);
 
-	mSceneContentGenerator = new TerrainContentGenerator(mSceneMgr);
-	mSceneContentGenerator->GenerateScene(300, "robot.mesh");
+	mTerrainContentGenerator = new TerrainContentGenerator(mSceneMgr);
+	mTerrainContentGenerator->GenerateScene(300, "robot.mesh");
 	// no limitations now: the user can set objects also on peaks
-	mSceneContentGenerator->SetMaxHeight(5000); 
+	mTerrainContentGenerator->SetMaxHeight(5000); 
 }
 //-----------------------------------------------------------------------
@@ -119,5 +119,5 @@
 {
 	mFrameListener= new MouseQueryListener(mWindow, mCamera, mSceneMgr, 
-		mGUIRenderer, mSceneContentGenerator);
+		mGUIRenderer, mTerrainContentGenerator);
 	mFrameListener->showDebugOverlay(true);
 	mRoot->addFrameListener(mFrameListener);
@@ -144,5 +144,5 @@
 	mRMouseDown = false;
 	mSceneMgr = sceneManager;
-	mSceneContentGenerator = sceneGenerator;
+	mTerrainContentGenerator = sceneGenerator;
 
     // Reduce move speed
@@ -207,5 +207,5 @@
 		 
 		 // Get results, create a node/entity on the position
-		 mCurrentObject = mSceneContentGenerator->GenerateSceneObject(
+		 mCurrentObject = mTerrainContentGenerator->GenerateSceneObject(
 			 mouseRay.getOrigin(), mouseRay.getDirection(), "robot.mesh");
 		
Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 80)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 82)
@@ -86,5 +86,5 @@
 
 	RayQueryExecutor *mRayQueryExecutor;
-	TerrainContentGenerator *mSceneContentGenerator;
+	TerrainContentGenerator *mTerrainContentGenerator;
 };
 
@@ -111,5 +111,5 @@
 	Vector3 mMaxAngle;
 
-	TerrainContentGenerator *mSceneContentGenerator;
+	TerrainContentGenerator *mTerrainContentGenerator;
 
 private: